<template>
	<div class="app-container">
		<el-form :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch" label-width="68px">
			<el-form-item label="班次编码" prop="shiftCode">
				<el-input
					v-model="queryParams.shiftCode"
					placeholder="请输入班次编码"
					clearable
					@keyup.enter.native="handleQuery"
				/>
			</el-form-item>
			<el-form-item label="班次名称" prop="shiftDescGlobal">
				<el-input
					v-model="queryParams.shiftDescGlobal"
					placeholder="请输入班次名称"
					clearable
					@keyup.enter.native="handleQuery"
				/>
			</el-form-item>
			<el-form-item>
				<el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
				<el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
			</el-form-item>
		</el-form>

		<el-row :gutter="10" class="mb8">
			<el-col :span="1.5">
				<el-button
					type="primary"
					plain
					icon="el-icon-plus"
					size="mini"
					@click="handleAdd"
					v-hasPermi="['wms:shifts:add']"
				>新增</el-button>
			</el-col>
			<el-col :span="1.5">
				<el-button
					type="success"
					plain
					icon="el-icon-edit"
					size="mini"
					:disabled="single"
					@click="handleUpdate"
					v-hasPermi="['wms:shifts:edit']"
				>修改</el-button>
			</el-col>
			<el-col :span="1.5">
				<el-button
					type="danger"
					plain
					icon="el-icon-delete"
					size="mini"
					:disabled="multiple"
					@click="handleDelete"
					v-hasPermi="['wms:shifts:remove']"
				>删除</el-button>
			</el-col>
			<el-col :span="1.5">
				<el-button
					type="warning"
					plain
					icon="el-icon-download"
					size="mini"
					@click="handleExport"
					v-hasPermi="['wms:shifts:export']"
				>导出</el-button>
			</el-col>
			<right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
		</el-row>

		<el-table v-loading="loading" :data="shiftsList" @selection-change="handleSelectionChange">
			<el-table-column type="selection" width="55" align="center" />
			<!-- 序号 -->
      		<el-table-column
        		type="index"
        		width="90"
        		align="center"
        		:index="indexMethod"
       			 label="序号">
      		</el-table-column>
			<el-table-column label="班次编码" align="center" prop="shiftCode" />
			<el-table-column label="班次名称" align="center" prop="shiftDescGlobal" />
			<el-table-column label="开始时间" align="center" prop="shiftStartTime" />
      		<el-table-column label="结束时间" align="center" prop="shiftEndTime" />
			<el-table-column label="创建人" align="center" prop="createBy" />
			<el-table-column label="创建时间" align="center" prop="createDate"/>
			<el-table-column prop="active" label="是否启用" align="center">
        		<template slot-scope="scope">
          			{{ scope.row.active == 1 ? "是" : "否" }}
        		</template>
      		</el-table-column>
			<el-table-column label="操作" align="center" class-name="small-padding fixed-width">
				<template slot-scope="scope">
					<el-button
						size="mini"
						type="text"
						icon="el-icon-edit"
						@click="handleUpdate(scope.row)"
						v-hasPermi="['wms:shifts:edit']"
					>修改</el-button>
					<el-button
						size="mini"
						type="text"
						icon="el-icon-delete"
						@click="handleDelete(scope.row)"
						v-hasPermi="['wms:shifts:remove']"
					>删除</el-button>
				</template>
			</el-table-column>
		</el-table>

		<pagination
			v-show="total>0"
			:total="total"
			:page.sync="queryParams.pageNum"
			:limit.sync="queryParams.pageSize"
			@pagination="getList"
		/>

		<!-- 添加或修改班次管理对话框 -->
		<el-dialog :title="title" :visible.sync="open" width="500px" append-to-body>
			<el-form ref="form" :model="form" :rules="rules" label-width="100px">
				<el-form-item label="班次编码" prop="shiftCode" style="width:400px">
					<el-input v-model="form.shiftCode" placeholder="请输入班次编码" />
				</el-form-item>
				<el-form-item label="班次名称" prop="shiftDescGlobal" style="width:400px">
					<el-input v-model="form.shiftDescGlobal" placeholder="请输入班次名称" />
				</el-form-item>
				<el-form-item label="开始时间" prop="shiftStartTime" style="width:400px">
        	<el-time-select
            v-model="form.shiftStartTime"
            :picker-options="{
              start: '00:00',
              step: '01:00',
              end: '23:00'
            }"
            placeholder="选择班次开始时间" style="width:300px">
          </el-time-select>
        </el-form-item>
        <el-form-item label="结束时间" prop="shiftEndTime" >
          <el-time-select
            v-model="form.shiftEndTime"
              :picker-options="{
              start: '00:00',
              step: '01:00',
              end: '23:00'
            }"
            placeholder="选择班次结束时间" style="width:300px">
          </el-time-select>
        </el-form-item>
        <el-form-item label="是否启用" prop="active">
          <el-select v-model="form.active" placeholder="请选择是否启用"  @change="$forceUpdate()" clearable style="width:300px">
            <el-option v-for="item in options" :key="item.active" :label="item.label" :value="item.active"></el-option>
          </el-select>
        </el-form-item>
			</el-form>
			<div slot="footer" class="dialog-footer">
				<el-button type="primary" @click="submitForm">确 定</el-button>
				<el-button @click="cancel">取 消</el-button>
			</div>
		</el-dialog>
	</div>
</template>

<script>
import { listShifts, getShifts, delShifts, addShifts, updateShifts } from "@/api/wms/shifts";

export default {
	name: "Shifts",
	data() {
		return {
			// 遮罩层
			loading: true,
			// 选中数组
			ids: [],
			// 非单个禁用
			single: true,
			// 非多个禁用
			multiple: true,
			// 显示搜索条件
			showSearch: true,
			// 总条数
			total: 0,
			// 班次管理表格数据
			shiftsList: [],
			// 弹出层标题
			title: "",
			// 是否显示弹出层
			open: false,
			// 查询参数
			queryParams: {
				pageNum: 1,
				pageSize: 10,
				shiftCode: null,
				shiftDesc: null,
				shiftDescGlobal: null,
				shiftDescExtended: null,
				shiftStartTime: null,
				shiftEndTime: null,
				createBy: null,
				createDate: null,
				lastUpdateBy: null,
				lastUpdateDate: null,
				Active: null,
				enterpriseId: null,
				enterpriseCode: null,
				siteId: null,
				siteCode: null
			},
			options: [{
                active: "1",
                label: '是'
              }, {
                active: "0",
                label: '否'
              }],
			// 表单参数
			form: {},
			// 表单校验
			rules: {
			}
		};
	},
	created() {
		this.getList();
	},
	methods: {
		// 生成表头序号
    indexMethod(index) {
      return index + 1;
    },
		/** 查询班次管理列表 */
		getList() {
			this.loading = true;
			listShifts(this.queryParams).then(response => {
				this.shiftsList = response.rows;
				this.total = response.total;
				this.loading = false;
			});
		},
	  // 取消按钮
		cancel() {
			this.open = false;
			this.reset();
		},
		// 表单重置
		reset() {
			this.form = {
				shiftId: null,
				shiftCode: null,
				shiftDesc: null,
				shiftDescGlobal: null,
				shiftDescExtended: null,
				shiftStartTime: null,
				shiftEndTime: null,
				createBy: null,
				createDate: null,
				lastUpdateBy: null,
				lastUpdateDate: null,
				Active: null,
				enterpriseId: null,
				enterpriseCode: null,
				siteId: null,
				siteCode: null
			};
			this.resetForm("form");
		},
		/** 搜索按钮操作 */
		handleQuery() {
			this.queryParams.pageNum = 1;
			this.getList();
		},
		/** 重置按钮操作 */
		resetQuery() {
			this.resetForm("queryForm");
			this.handleQuery();
		},
		// 多选框选中数据
		handleSelectionChange(selection) {
			this.ids = selection.map(item => item.shiftId)
			this.single = selection.length!==1
			this.multiple = !selection.length
		},
		/** 新增按钮操作 */
		handleAdd() {
			this.reset();
			this.open = true;
			this.title = "添加班次管理";
		},
		/** 修改按钮操作 */
		handleUpdate(row) {
			this.reset();
			const shiftId = row.shiftId || this.ids
			getShifts(shiftId).then(response => {
				this.form = response.data;
				this.open = true;
				this.title = "修改班次管理";
			});
		},
		/** 提交按钮 */
		submitForm() {
			this.$refs["form"].validate(valid => {
				if (valid) {
					if (this.form.shiftId != null) {
						updateShifts(this.form).then(response => {
							this.$modal.msgSuccess("修改成功");
							this.open = false;
							this.getList();
						});
					} else {
						addShifts(this.form).then(response => {
							this.$modal.msgSuccess("新增成功");
							this.open = false;
							this.getList();
						});
					}
				}
			});
		},
		/** 删除按钮操作 */
		handleDelete(row) {
			const shiftIds = row.shiftId || this.ids;
			this.$modal.confirm('是否确认删除班次管理编号为"' + shiftIds + '"的数据项？').then(function() {
				return delShifts(shiftIds);
			}).then(() => {
				this.getList();
				this.$modal.msgSuccess("删除成功");
			}).catch(() => {});
		},
		/** 导出按钮操作 */
		handleExport() {
			this.download('wms/shifts/export', {
				...this.queryParams
			}, `shifts_${new Date().getTime()}.xlsx`)
		}
	}
};
</script>
